from typing import List, Dict, Tuple, Optional


# from du0201 2018
#REG: (N, \Sigma, P, S)
Terminal = str
Nonterminal = str
Rules = Dict[Nonterminal, List[Tuple[Terminal, Optional[Nonterminal]]]]
REG = Tuple[List[Nonterminal],
            List[Terminal],
            Rules,
            Nonterminal]


#DFA: (Q, \Sigma, \delta, q_0, F)
State = str
Transition = Dict[Tuple[State, Terminal], State]
DFA = Tuple[List[State],
            List[Terminal],
            Transition,
            State,
            List[State]]


#NFA: (Q, \Sigma, \delta, q_0, F)
N_Transition = List[Tuple[State, Terminal], State]
NFA = Tuple[List[State],
            List[Terminal],
            N_Transition,
            State,
            List[State]]


def total(dfa: DFA) -> DFA:
    states, terms, partial_fn, init, accept = dfa
    total_fn = Transition
    hell = State
    states.add(hell)

    for state in states:
        for term in terms:
            if partial_fn[state, term]:
                total_fn[state, term] = partial_fn[state, term]
            else:
                total_fn[state, term] = hell

    return states, terms, total_fn, init, accept



